
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	POSNUM	258
#define	NEGNUM	259
#define	FUNCID0	260
#define	FUNCID1	261
#define	FUNCID2	262
#define	FUNCID3	263
#define	FUNCID4	264
#define	FUNCID5	265
#define	FUNCID6	266
#define	FUNCID7	267
#define	FUNCID8	268
#define	FUNCDEF	269
#define	INLINE_INFIX	270
#define	INLINE_PREFIX	271
#define	INLINE_POSTFIX	272
#define	BEGINBLOCK	273
#define	ENDBLOCK	274
#define	WHILE_CONS	275
#define	IF_CONS	276
#define	IFELSE_CONS	277
#define	INFIX_EXPR	278
#define	POSTFIX_EXPR	279
#define	PREFIX_EXPR	280
#define	NEG	281
#define	SEPAR	282
#define	EQUALS	283
#define	EQ_CMP	284
#define	NE_CMP	285
#define	CMP_CMP	286
#define	LT_CMP	287
#define	GT_CMP	288
#define	LE_CMP	289
#define	GE_CMP	290
#define	LOGICAL_XOR	291
#define	LOGICAL_OR	292
#define	LOGICAL_AND	293
#define	LOGICAL_NOT	294
#define	UMINUS	295

#line 21 "parse.y"

#include <glib.h>
#include <string.h>
#include "mpwrap.h"
#include "eval.h"
#include "dict.h"
#include "util.h"
#include "calc.h"

/*functions defined in lexer*/
void push_notation(notation_t not);
void pop_notation(void);
	
extern evalstack_t evalstack;

extern int return_ret; /*should the lexer return on \n*/
extern calc_error_t error_num;

#define PUSH_ACT(ACT) stack_push(&evalstack, makefuncb(ACT,&evalstack));
#define PUSH_FUNC(FUNC) stack_push(&evalstack,makefuncd(FUNC,&evalstack));
#define PUSH_FAKEFUNC(FUNC) stack_push(&evalstack,makefuncd0(FUNC));

/*pops the last expression, pushes a marker
  entry and puts the last expression back*/
static int
push_marker(node_type_t markertype)
{
	tree_t * last_expr = stack_pop(&evalstack);
	tree_t * tree;
	
	if(!last_expr)
		return FALSE;
       
	tree = g_new(tree_t,1);
	tree->type = markertype;
	memset(tree->args,0,sizeof(void *)*8);
	stack_push(&evalstack,tree);
	stack_push(&evalstack,last_expr);
	return TRUE;
}
	
/*gather all expressions up until a row start marker and push the
  result as a MATRIX_ROW_NODE*/
static int
push_matrix_row(void)
{
	tree_t *tree;
	GList *row = NULL;
	GList *row_last = NULL;
	int i=0;
	for(;;) {
		tree = stack_pop(&evalstack);
		/*we have gone all the way to the top and haven't found a
		  marker*/
		if(!tree) {
			g_list_foreach(row,(GFunc)freetree,NULL);
			g_list_free(row); 
			return FALSE;
		}
		if(tree->type==MATRIX_ROW_START_NODE) {
			freetree(tree);
			break;
		}
		if(!row) {
			row = g_list_append(NULL,tree);
			row_last = row;
		} else {
			row_last = g_list_append(row_last,tree);
			row_last = g_list_next(row_last);
		}
		i++;
	}
	tree = g_new(tree_t,1);
	tree->type = MATRIX_ROW_NODE;
	tree->data.matrixrow.list = row;
	tree->data.matrixrow.size = i;
	memset(tree->args,0,sizeof(void *)*8);

	stack_push(&evalstack,tree);
}
	
/*gather all expressions up until a row start marker and push the
  result as a matrix*/
static int
push_matrix(void)
{
	/*FIXME: add matrix code here*/
	return TRUE;
}

/*pushes a NULL onto the stack, null cannot be evaluated, it will be
  read as ""*/
static void
push_null(void)
{
	tree_t *tree;
	tree = g_new(tree_t,1);
	tree->type = NULL_NODE;
	memset(tree->args,0,sizeof(void *)*8);

	stack_push(&evalstack,tree);
}


#line 126 "parse.y"
typedef union {
	mpw_t val;
	func_t *func;
	char *id;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		462
#define	YYFLAG		-32768
#define	YYNTBASE	57

#define YYTRANSLATE(x) ((unsigned)(x) <= 295 ? yytranslate[x] : 82)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    49,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    45,     2,     2,     2,    44,     2,     2,    50,
    52,    42,    40,    51,    41,    55,    43,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    56,     2,     2,
     2,     2,     2,    48,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    53,     2,    54,    46,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    47
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     8,    12,    15,    18,    21,    23,    25,    27,
    30,    32,    36,    40,    44,    48,    52,    56,    60,    64,
    68,    72,    76,    80,    84,    88,    92,    96,   100,   103,
   106,   109,   112,   116,   124,   131,   138,   144,   146,   149,
   153,   157,   162,   164,   168,   170,   172,   177,   182,   187,
   191,   193,   197,   199,   203,   207,   209,   214,   221,   230,
   241,   254,   269,   286,   305,   309,   311,   315,   319,   323,
   327,   331,   335,   339,   343,   347,   351,   355,   359,   363,
   367,   371,   375,   378,   381,   384,   388,   396,   403,   410,
   416,   418,   421,   425,   429,   434,   436,   440,   442,   444,
   449,   454,   459,   463,   465,   469,   471,   475,   479,   481,
   484,   488,   493,   499,   506,   514,   523,   533,   537,   539,
   543,   547,   551,   555,   559,   563,   567,   571,   575,   579,
   583,   587,   591,   595,   599,   603,   607,   610,   613,   617,
   625,   632,   639,   645,   647,   650,   654,   658,   663,   665,
   669,   671,   673,   678,   683,   688,   692,   694,   698,   700,
   704,   708,   710,   713,   717,   722,   728,   735,   743,   752,
   762,   764,   766,   768,   770
};

static const short yyrhs[] = {    23,
    58,    49,     0,    24,    64,    49,     0,    25,    71,    49,
     0,    23,    49,     0,    24,    49,     0,    25,    49,     0,
    23,     0,    24,     0,    25,     0,     1,    49,     0,     1,
     0,    58,    27,    58,     0,    58,    28,    58,     0,    58,
    40,    58,     0,    58,    41,    58,     0,    58,    42,    58,
     0,    58,    43,    58,     0,    58,    44,    58,     0,    58,
    29,    58,     0,    58,    30,    58,     0,    58,    31,    58,
     0,    58,    32,    58,     0,    58,    33,    58,     0,    58,
    34,    58,     0,    58,    35,    58,     0,    58,    38,    58,
     0,    58,    37,    58,     0,    58,    36,    58,     0,    39,
    58,     0,    58,    45,     0,    26,    58,     0,    41,    58,
     0,    58,    46,    58,     0,    48,    58,    50,    58,    51,
    58,    52,     0,    48,    58,    50,    51,    58,    52,     0,
    48,    58,    50,    58,    51,    52,     0,    48,    58,    50,
    51,    52,     0,    63,     0,    78,    62,     0,    20,    58,
    61,     0,    21,    58,    61,     0,    22,    58,    61,    61,
     0,    61,     0,    53,    60,    54,     0,    80,     0,    55,
     0,    15,    50,    58,    52,     0,    16,    50,    72,    52,
     0,    17,    50,    65,    52,     0,    59,    51,    58,     0,
    58,     0,    60,    56,    59,     0,    59,     0,    50,    58,
    52,     0,    18,    58,    19,     0,     5,     0,     6,    50,
    58,    52,     0,     7,    50,    58,    51,    58,    52,     0,
     8,    50,    58,    51,    58,    51,    58,    52,     0,     9,
    50,    58,    51,    58,    51,    58,    51,    58,    52,     0,
    10,    50,    58,    51,    58,    51,    58,    51,    58,    51,
    58,    52,     0,    11,    50,    58,    51,    58,    51,    58,
    51,    58,    51,    58,    51,    58,    52,     0,    12,    50,
    58,    51,    58,    51,    58,    51,    58,    51,    58,    51,
    58,    51,    58,    52,     0,    13,    50,    58,    51,    58,
    51,    58,    51,    58,    51,    58,    51,    58,    51,    58,
    51,    58,    52,     0,    64,    27,    65,     0,    65,     0,
    65,    65,    28,     0,    65,    65,    40,     0,    65,    65,
    41,     0,    65,    65,    42,     0,    65,    65,    43,     0,
    65,    65,    44,     0,    65,    65,    29,     0,    65,    65,
    30,     0,    65,    65,    31,     0,    65,    65,    32,     0,
    65,    65,    33,     0,    65,    65,    34,     0,    65,    65,
    35,     0,    65,    65,    38,     0,    65,    65,    37,     0,
    65,    65,    36,     0,    65,    39,     0,    65,    26,     0,
    65,    45,     0,    65,    65,    46,     0,    50,    65,    51,
    65,    52,    65,    48,     0,    50,    51,    65,    52,    65,
    48,     0,    50,    65,    51,    52,    65,    48,     0,    50,
    51,    52,    65,    48,     0,    70,     0,    78,    69,     0,
    65,    65,    20,     0,    65,    65,    21,     0,    65,    65,
    65,    22,     0,    68,     0,    53,    67,    54,     0,    79,
     0,    55,     0,    15,    50,    58,    52,     0,    16,    50,
    72,    52,     0,    17,    50,    65,    52,     0,    66,    51,
    65,     0,    65,     0,    67,    56,    66,     0,    66,     0,
    50,    64,    52,     0,    18,    64,    19,     0,     5,     0,
    65,     6,     0,    65,    65,     7,     0,    65,    65,    65,
     8,     0,    65,    65,    65,    65,     9,     0,    65,    65,
    65,    65,    65,    10,     0,    65,    65,    65,    65,    65,
    65,    11,     0,    65,    65,    65,    65,    65,    65,    65,
    12,     0,    65,    65,    65,    65,    65,    65,    65,    65,
    13,     0,    71,    27,    72,     0,    72,     0,    28,    72,
    72,     0,    40,    72,    72,     0,    41,    72,    72,     0,
    42,    72,    72,     0,    43,    72,    72,     0,    44,    72,
    72,     0,    29,    72,    72,     0,    30,    72,    72,     0,
    31,    72,    72,     0,    32,    72,    72,     0,    33,    72,
    72,     0,    34,    72,    72,     0,    35,    72,    72,     0,
    38,    72,    72,     0,    37,    72,    72,     0,    36,    72,
    72,     0,    39,    72,    72,     0,    26,    72,     0,    45,
    72,     0,    46,    72,    72,     0,    48,    72,    50,    72,
    51,    72,    52,     0,    48,    72,    50,    51,    72,    52,
     0,    48,    72,    50,    72,    51,    52,     0,    48,    72,
    50,    51,    52,     0,    77,     0,    78,    76,     0,    20,
    72,    75,     0,    21,    72,    75,     0,    22,    72,    75,
    75,     0,    75,     0,    53,    74,    54,     0,    79,     0,
    55,     0,    15,    50,    58,    52,     0,    16,    50,    72,
    52,     0,    17,    50,    65,    52,     0,    73,    51,    72,
     0,    72,     0,    74,    56,    73,     0,    73,     0,    50,
    71,    52,     0,    18,    71,    19,     0,     5,     0,     6,
    72,     0,     7,    72,    72,     0,     8,    72,    72,    72,
     0,     9,    72,    72,    72,    72,     0,    10,    72,    72,
    72,    72,    72,     0,    11,    72,    72,    72,    72,    72,
    72,     0,    12,    72,    72,    72,    72,    72,    72,    72,
     0,    13,    72,    72,    72,    72,    72,    72,    72,    72,
     0,    14,     0,    80,     0,    81,     0,     3,     0,     4,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
   188,   191,   192,   193,   194,   195,   196,   197,   198,   199,
   200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
   210,   211,   212,   213,   215,   217,   219,   220,   221,   222,
   223,   224,   226,   227,   228,   229,   230,   231,   232,   235,
   236,   239,   240,   243,   246,   249,   251,   253,   255,   257,
   259,   262,   265,   268,   273,   274,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
   291,   292,   293,   294,   295,   296,   297,   299,   301,   303,
   304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
   314,   315,   318,   319,   322,   323,   327,   331,   334,   336,
   338,   340,   342,   344,   346,   348,   350,   354,   355,   358,
   359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
   369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
   380,   382,   384,   385,   386,   387,   388,   389,   391,   392,
   393,   394,   395,   396,   397,   400,   401,   404,   405,   408,
   411,   414,   416,   418,   420,   422,   424,   426,   428,   430,
   434,   437,   438,   441,   447
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","POSNUM",
"NEGNUM","FUNCID0","FUNCID1","FUNCID2","FUNCID3","FUNCID4","FUNCID5","FUNCID6",
"FUNCID7","FUNCID8","FUNCDEF","INLINE_INFIX","INLINE_PREFIX","INLINE_POSTFIX",
"BEGINBLOCK","ENDBLOCK","WHILE_CONS","IF_CONS","IFELSE_CONS","INFIX_EXPR","POSTFIX_EXPR",
"PREFIX_EXPR","NEG","SEPAR","EQUALS","EQ_CMP","NE_CMP","CMP_CMP","LT_CMP","GT_CMP",
"LE_CMP","GE_CMP","LOGICAL_XOR","LOGICAL_OR","LOGICAL_AND","LOGICAL_NOT","'+'",
"'-'","'*'","'/'","'%'","'!'","'^'","UMINUS","'@'","'\\n'","'('","','","')'",
"'['","']'","'.'","':'","expr","inexpr","inmatrixrow","inmatrixrows","inparenth",
"inblock","infunc","poexprlist","poexpr","pomatrixrow","pomatrixrows","poparenth",
"poblock","pofunc","prexprlist","prexpr","prmatrixrow","prmatrixrows","prparenth",
"prblock","prfunc","funcdef","num","posnum","negnum", NULL
};
#endif

static const short yyr1[] = {     0,
    57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
    57,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    59,
    59,    60,    60,    61,    62,    63,    63,    63,    63,    63,
    63,    63,    63,    63,    64,    64,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    66,    66,    67,    67,    68,    69,    70,    70,
    70,    70,    70,    70,    70,    70,    70,    71,    71,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    73,    73,    74,    74,    75,
    76,    77,    77,    77,    77,    77,    77,    77,    77,    77,
    78,    79,    79,    80,    81
};

static const short yyr2[] = {     0,
     3,     3,     3,     2,     2,     2,     1,     1,     1,     2,
     1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
     2,     2,     3,     7,     6,     6,     5,     1,     2,     3,
     3,     4,     1,     3,     1,     1,     4,     4,     4,     3,
     1,     3,     1,     3,     3,     1,     4,     6,     8,    10,
    12,    14,    16,    18,     3,     1,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     2,     2,     2,     3,     7,     6,     6,     5,
     1,     2,     3,     3,     4,     1,     3,     1,     1,     4,
     4,     4,     3,     1,     3,     1,     3,     3,     1,     2,
     3,     4,     5,     6,     7,     8,     9,     3,     1,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     2,     2,     3,     7,
     6,     6,     5,     1,     2,     3,     3,     4,     1,     3,
     1,     1,     4,     4,     4,     3,     1,     3,     1,     3,
     3,     1,     2,     3,     4,     5,     6,     7,     8,     9,
     1,     1,     1,     1,     1
};

static const short yydefact[] = {     0,
    11,     7,     8,     9,    10,   174,    56,     0,     0,     0,
     0,     0,     0,     0,     0,   171,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     4,     0,     0,    46,
     0,    43,    38,     0,    45,   175,   109,     0,     0,     0,
     5,     0,     0,    99,     0,    66,    96,    91,     0,    98,
   172,   173,   162,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     6,     0,
     0,   152,     0,   119,   149,   144,     0,   151,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    31,    29,    32,     0,     0,    51,    53,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    30,     0,     1,
     0,    39,     0,     0,     0,     0,     0,    66,   104,   106,
     0,     0,     2,   110,    84,    83,    85,     0,     0,    92,
   163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   137,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   138,     0,     0,     0,   157,   159,     0,     0,
     3,     0,   145,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    40,    41,     0,     0,    54,     0,
    44,     0,    12,    13,    19,    20,    21,    22,    23,    24,
    25,    28,    27,    26,    14,    15,    16,    17,    18,    33,
     0,     0,     0,     0,     0,     0,   107,     0,     0,    97,
     0,    65,   111,    93,    94,    67,    73,    74,    75,    76,
    77,    78,    79,    82,    81,    80,    68,    69,    70,    71,
    72,    86,     0,     0,   164,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   146,   147,     0,   120,   126,   127,
   128,   129,   130,   131,   132,   135,   134,   133,   136,   121,
   122,   123,   124,   125,   139,     0,   160,     0,   150,     0,
   118,     0,    57,     0,     0,     0,     0,     0,     0,     0,
    47,    48,    49,    42,     0,     0,    50,    52,    55,   100,
   101,   102,     0,     0,     0,     0,   103,   105,   112,    95,
     0,   108,   165,     0,     0,     0,     0,     0,   153,   154,
   155,   148,     0,     0,   156,   158,   161,     0,     0,     0,
     0,     0,     0,     0,    37,     0,     0,    90,     0,     0,
     0,   113,     0,   166,     0,     0,     0,     0,   143,     0,
     0,    58,     0,     0,     0,     0,     0,     0,    35,    36,
     0,    88,    89,     0,   114,     0,   167,     0,     0,     0,
   141,   142,     0,     0,     0,     0,     0,     0,     0,    34,
    87,   115,     0,   168,     0,     0,   140,    59,     0,     0,
     0,     0,     0,   116,     0,   169,     0,     0,     0,     0,
     0,     0,   117,   170,    60,     0,     0,     0,     0,     0,
     0,     0,     0,    61,     0,     0,     0,     0,     0,     0,
    62,     0,     0,     0,     0,    63,     0,     0,    64,     0,
     0,     0
};

static const short yydefgoto[] = {   460,
   118,   119,   120,    32,   142,    33,    45,   158,   150,   151,
    47,   160,    48,    93,    94,   198,   199,    95,   203,    96,
    97,    98,    51,    52
};

static const short yypact[] = {    55,
   -39,   219,   275,   570,-32768,-32768,-32768,   -18,    -7,    -1,
     8,    35,    43,    45,    46,-32768,    56,    58,    59,  1831,
  1831,  1831,  1831,  1831,  1831,  1831,-32768,  1831,  1831,-32768,
  3198,-32768,-32768,    70,-32768,-32768,-32768,    60,    61,    62,
-32768,   292,   928,-32768,   -16,  2032,-32768,-32768,    95,-32768,
-32768,-32768,-32768,  1464,  1464,  1464,  1464,  1464,  1464,  1464,
  1464,    65,    66,    86,  1464,  1464,  1464,  1464,  1464,  1464,
  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1464,
  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1464,-32768,  1464,
  1464,-32768,     1,-32768,-32768,-32768,   120,-32768,  1831,  1831,
  1831,  1831,  1831,  1831,  1831,  1831,  1831,  1464,   928,  3150,
  3150,  3150,-32768,  3258,-32768,  3174,  2061,  1266,    89,   -25,
  1831,  1831,  1831,  1831,  1831,  1831,  1831,  1831,  1831,  1831,
  1831,  1831,  1831,  1831,  1831,  1831,  1831,-32768,  1831,-32768,
  1831,-32768,  1831,  1464,   928,   410,   -22,   249,  2032,    94,
    33,   928,-32768,-32768,-32768,-32768,-32768,  1729,   928,-32768,
-32768,  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1831,  1464,
   928,    98,    98,    98,-32768,  1464,  1464,  1464,  1464,  1464,
  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1464,  1464,
  1464,  1464,-32768,  1464,    99,   -10,-32768,   100,    38,  1464,
-32768,  1464,-32768,  2087,  2425,  2450,  2475,  2500,  2525,  2550,
  2575,  2113,   101,   517,-32768,-32768,   102,   848,-32768,  1831,
-32768,  1831,  3220,   426,  3277,  3277,  3277,   316,   316,   316,
   316,  3239,  3239,  3258,   -30,   -30,     9,     9,     9,   108,
  1035,  2139,   103,   982,   928,  1395,-32768,   751,   928,-32768,
   928,  2032,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    31,    63,-32768,  1464,  1464,  1464,  1464,  1464,
  1464,  2165,   106,  1859,-32768,-32768,    98,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  1129,-32768,  1464,-32768,  1464,
-32768,    64,-32768,  1831,  1831,  1831,  1831,  1831,  1831,  1831,
-32768,-32768,-32768,-32768,   696,  2600,  1266,    89,-32768,-32768,
-32768,-32768,  1891,   928,   928,  1917,  2032,    94,-32768,-32768,
  1676,-32768,-32768,  1464,  1464,  1464,  1464,  1464,-32768,-32768,
-32768,-32768,  1237,   117,-32768,   100,-32768,  2191,  2625,  2650,
  2675,  2700,  2725,  2750,-32768,  2217,  1780,-32768,  1949,  1975,
   928,-32768,   156,-32768,  1464,  1464,  1464,  1464,-32768,   122,
  1322,-32768,  1831,  1831,  1831,  1831,  1831,  1831,-32768,-32768,
  2243,-32768,-32768,  2028,-32768,  1623,-32768,  1464,  1464,  1464,
-32768,-32768,   123,  2269,  2775,  2800,  2825,  2850,  2875,-32768,
-32768,-32768,  1570,-32768,  1464,  1464,-32768,-32768,  1831,  1831,
  1831,  1831,  1831,-32768,  1517,-32768,  1464,  2295,  2900,  2925,
  2950,  2975,-32768,-32768,-32768,  1831,  1831,  1831,  1831,  2321,
  3000,  3025,  3050,-32768,  1831,  1831,  1831,  2347,  3075,  3100,
-32768,  1831,  1831,  2373,  3125,-32768,  1831,  2399,-32768,   179,
   180,-32768
};

static const short yypgoto[] = {-32768,
   527,   -41,-32768,  -103,-32768,-32768,   -17,   678,   -68,-32768,
-32768,-32768,-32768,   -84,  1039,  -107,-32768,  -170,-32768,-32768,
    -2,   634,   375,-32768
};


#define	YYLAST		3323


static const short yytable[] = {    34,
    49,   285,   286,   287,   152,   196,   215,   216,   217,     5,
   152,   135,   136,   137,   138,   139,   200,    34,    34,    34,
    34,    34,    34,    34,   147,    34,    34,   200,   221,   247,
   222,    99,   153,     6,    36,    37,   154,   253,   339,    49,
    49,   307,   100,    49,    16,    38,    39,    40,   101,   201,
   254,   255,   340,   138,   139,     1,   155,   102,   256,   257,
   258,   259,   260,   261,   262,   263,   264,   265,   266,   156,
   267,   268,   269,   270,   271,   157,   272,     2,     3,     4,
    42,   342,   357,    43,   103,    44,   250,   141,   251,   152,
   200,   309,   104,   310,   105,   106,    34,    34,    34,    34,
    34,    34,    34,    34,    34,   107,    49,   108,   109,   143,
   144,   145,   159,   324,   169,   170,   352,   312,    34,    34,
    34,    34,    34,    34,    34,    34,    34,    34,    34,    34,
    34,    34,    34,    34,    34,   171,    34,   202,    34,   220,
    34,   274,    49,    49,   249,    49,    49,    90,   306,    49,
   308,    28,   322,   139,   331,    49,    49,   350,     6,    36,
    37,   154,   253,   339,   372,   395,    34,   381,    49,    16,
    38,    39,    40,   401,   417,   254,   255,   340,   461,   462,
   328,   155,   338,   256,   257,   258,   259,   260,   261,   262,
   263,   264,   265,   266,   156,   267,   268,   269,   270,   271,
   157,   272,   356,     0,     0,    42,     0,     0,    43,     0,
    44,    49,     0,     0,     0,    34,     0,    34,     0,    34,
     0,     6,     0,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,     0,     0,    20,    21,
    22,    49,    49,    49,    23,    49,    49,     0,    49,    49,
     0,     6,    36,    37,   154,     0,     0,    24,     0,    25,
     0,     0,    16,    38,    39,    40,    26,    27,    28,     0,
    49,    29,     0,    30,   155,     0,     0,     6,    36,    37,
     0,    49,     0,     0,     0,     0,     0,   156,    16,    38,
    39,    40,     0,   157,     6,    36,    37,     0,    42,   248,
     0,    43,     0,    44,     0,    16,    38,    39,    40,     0,
     0,    34,    34,    34,    34,    34,    34,    34,     0,     0,
     0,     0,    34,    41,    42,     0,     0,    43,     0,    44,
    49,    49,    49,    49,    49,     0,     0,     0,    49,     0,
     0,    42,   146,   122,    43,     0,    44,-32768,-32768,-32768,
-32768,     0,     0,     0,     0,   133,   134,   135,   136,   137,
   138,   139,     0,     0,    34,     0,    49,    49,    49,     0,
    49,     0,     0,     0,     0,     0,    35,     0,     0,     0,
    34,    34,    34,    34,    34,    34,     0,     0,     0,     0,
     0,    49,     0,    49,    35,    35,    35,    35,    35,    35,
    35,     0,    35,    35,     0,     0,     0,     0,     0,     0,
    49,     0,     6,    36,    37,     0,    34,    34,    34,    34,
    34,     0,    49,    16,    38,    39,    40,     0,     0,     0,
     0,     0,     0,    34,    34,    34,    34,     0,     0,     0,
     0,     0,    34,    34,    34,     0,     0,     0,     0,    34,
    34,     0,     0,   122,    34,     0,     0,     0,     0,    42,
     0,   245,    43,     0,    44,   133,   134,   135,   136,   137,
   138,   139,     0,    35,    35,    35,    35,    35,    35,    35,
    35,    35,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    35,    35,    35,    35,    35,
    35,    35,    35,    35,    35,    35,    35,    35,    35,    35,
    35,    35,     0,    35,     0,    35,     0,    35,     0,     6,
    36,    37,   154,     0,     0,     0,     0,     0,    31,     0,
    16,    38,    39,    40,     0,     0,     0,     0,     0,     0,
     0,     0,   155,    35,     0,     0,   110,   111,   112,   113,
   114,   115,   116,     0,   117,   156,     0,     0,     0,     0,
     0,   157,     0,     0,     0,     0,    42,     0,   323,    43,
     0,    44,     6,    36,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    16,    62,    63,    64,     0,     0,    65,
    66,    67,    35,     0,    35,    68,    35,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,     0,    88,    89,    90,
     0,     0,    91,     0,    92,   204,   205,   206,   207,   208,
   209,   210,   211,   212,     0,     0,    50,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   223,   224,   225,
   226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
   236,   237,   238,   239,     0,   240,     0,   241,     0,   242,
     0,     0,     0,     0,     0,    50,    50,     0,     0,    50,
    46,     0,     0,     0,     0,     0,     0,     0,    35,    35,
    35,    35,    35,    35,    35,   282,     0,     0,     6,    35,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,     0,     0,    20,    21,    22,     0,   148,
   149,    23,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    24,     0,    25,     0,     0,     0,
     0,    35,    50,    26,   326,    28,   327,   365,    29,     0,
    30,     0,     0,     6,    36,    37,     0,    35,    35,    35,
    35,    35,    35,     0,    16,    38,    39,    40,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    50,    50,
     0,    50,    50,     0,     0,    50,   214,     0,     0,     0,
     0,    50,    50,    35,    35,    35,    35,    35,     0,     0,
    42,     0,   335,    43,    50,    44,     0,     0,     0,     0,
    35,    35,    35,    35,     0,     0,     0,     0,     0,    35,
    35,    35,   244,   246,     0,     0,    35,    35,     0,   252,
     0,    35,     0,     0,     0,   273,    46,     0,     0,     0,
   358,   359,   360,   361,   362,   363,   364,    50,   284,     0,
     6,   366,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,     0,     0,    20,    21,    22,
     0,     0,     0,    23,     0,     0,     0,    50,    50,    50,
     0,    50,    50,     0,    50,    50,    24,     0,    25,     0,
     0,     0,     0,   391,     0,    26,     0,    28,   325,     0,
    29,     0,    30,     0,     0,     0,    50,     0,     0,   404,
   405,   406,   407,   408,   409,     0,     0,    50,     0,     0,
     0,     0,   333,     0,     0,   336,   337,     0,   149,     0,
     6,    36,    37,     0,     0,     0,     0,     0,     0,     0,
     0,    16,    38,    39,    40,   428,   429,   430,   431,   432,
   341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   440,   441,   442,   443,    50,    50,    50,    50,
    50,   448,   449,   450,    50,     0,     0,    42,   454,   455,
    43,     0,    44,   458,     6,    36,    37,   154,     0,     0,
     0,     0,     0,     0,     0,    16,    38,    39,    40,     0,
     0,     0,    50,    50,    50,     0,    50,   155,     0,     0,
     0,   369,   370,     0,     0,     0,     0,     0,   373,     0,
   156,     0,     0,     0,     0,     0,   157,    50,     0,    50,
     0,    42,     0,   332,    43,     0,    44,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    50,     0,   394,     0,
   396,     0,     0,   329,     0,     0,     0,     0,    50,     0,
     0,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,   413,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   425,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     0,     0,   425,   172,   173,   174,   175,   176,   177,   178,
   179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
   189,   190,   191,   192,   193,   194,   195,     0,     0,   197,
     0,     6,    36,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    16,    62,    63,    64,   213,     0,    65,    66,
    67,     0,     0,     0,    68,     0,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,     0,    88,     0,    90,   353,
     0,    91,   243,    92,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   275,   276,   277,   278,   279,   280,   281,     0,   283,     0,
     0,     0,     0,     0,   288,   289,   290,   291,   292,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
   304,     0,   305,     0,     0,     0,     0,     0,   311,     6,
    36,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    16,    62,    63,    64,     0,     0,    65,    66,    67,     0,
     0,     0,    68,     0,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    87,     0,    88,     0,    90,     0,   379,    91,
     0,    92,   121,   122,   123,   124,   125,   126,   127,   128,
   129,   130,   131,   132,     0,   133,   134,   135,   136,   137,
   138,   139,     0,     0,   343,   344,   345,   346,   347,   348,
     0,     0,     0,     0,     6,    36,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    16,    62,    63,    64,     0,
     0,    65,    66,    67,   354,     0,   355,    68,   197,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,     0,    88,
     0,    90,     0,   402,    91,     0,    92,     0,     0,     0,
     0,     0,   374,   375,   376,   377,   378,     0,     0,     0,
     0,   380,     0,     0,     0,     0,     0,     6,    36,    37,
   154,     0,     0,     0,     0,     0,     0,     0,    16,    38,
    39,    40,     0,   397,   398,   399,   400,     0,     0,   403,
   155,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   156,     0,     0,   414,   415,   416,   157,
     0,     0,     0,     0,    42,     0,   334,    43,     0,    44,
     0,     0,     0,   426,   427,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   434,     6,    36,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    16,    62,    63,
    64,     0,     0,    65,    66,    67,     0,     0,     0,    68,
     0,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
     0,    88,     0,    90,     0,     0,    91,     0,    92,     6,
    36,    37,   154,   253,   339,   372,   395,   412,   424,   433,
    16,    38,    39,    40,     0,     0,   254,   255,   340,     0,
     0,     0,   155,     0,   256,   257,   258,   259,   260,   261,
   262,   263,   264,   265,   266,   156,   267,   268,   269,   270,
   271,   157,   272,     0,     0,     0,    42,     0,     0,    43,
     0,    44,     6,    36,    37,   154,   253,   339,   372,   395,
   412,   424,     0,    16,    38,    39,    40,     0,     0,   254,
   255,   340,     0,     0,     0,   155,     0,   256,   257,   258,
   259,   260,   261,   262,   263,   264,   265,   266,   156,   267,
   268,   269,   270,   271,   157,   272,     0,     0,     0,    42,
     0,     0,    43,     0,    44,     6,    36,    37,   154,   253,
   339,   372,   395,   412,     0,     0,    16,    38,    39,    40,
     0,     0,   254,   255,   340,     0,     0,     0,   155,     0,
   256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
   266,   156,   267,   268,   269,   270,   271,   157,   272,     0,
     0,     0,    42,     0,     0,    43,     0,    44,     6,    36,
    37,   154,   253,   339,   372,     0,     0,     0,     0,    16,
    38,    39,    40,     0,     0,   254,   255,   340,     0,     0,
     0,   155,     0,   256,   257,   258,   259,   260,   261,   262,
   263,   264,   265,   266,   156,   267,   268,   269,   270,   271,
   157,   272,     0,     0,     0,    42,     0,     0,    43,     0,
    44,     6,    36,    37,   154,   253,     0,     0,     0,     0,
     0,     0,    16,    38,    39,    40,     0,     0,   254,   255,
     0,     0,     0,     0,   155,     0,   256,   257,   258,   259,
   260,   261,   262,   263,   264,   265,   266,   156,   267,   268,
   269,   270,   271,   157,   272,     0,     0,     0,    42,     0,
     0,    43,     6,    44,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,     0,     0,    20,
    21,    22,     0,     0,     0,    23,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    24,     0,
    25,     0,     0,     0,     0,     0,     0,    26,     0,    28,
     0,   390,    29,     6,    30,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,     0,     0,
    20,    21,    22,     0,     0,     0,    23,     0,     0,     0,
     0,     6,    36,    37,   154,     0,     0,     0,     0,    24,
     0,    25,    16,    38,    39,    40,     0,     0,    26,     0,
    28,     0,     0,    29,   155,    30,     0,     0,     0,     0,
     0,     0,     0,     6,    36,    37,   154,   156,     0,     0,
     0,     0,     0,   157,    16,    38,    39,    40,    42,     0,
   351,    43,     0,    44,     0,     0,   155,     0,     0,     6,
    36,    37,   154,     0,     0,     0,     0,     0,     0,   156,
    16,    38,    39,    40,     0,   157,     0,     0,   368,     0,
    42,     0,   155,    43,     0,    44,     0,     0,     0,     0,
     0,     6,    36,    37,   154,   156,     0,     0,     0,     0,
     0,   157,    16,    38,    39,    40,    42,     0,   371,    43,
     0,    44,     0,     0,   155,     0,     0,     6,    36,    37,
   154,     0,     0,     0,     0,     0,     0,   156,    16,    38,
    39,    40,     0,   157,     0,     0,   392,     0,    42,     0,
   155,    43,     0,    44,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   156,     0,     0,     0,     0,     0,   157,
     0,     0,   393,     0,    42,     0,     0,    43,     0,    44,
     6,    36,    37,   154,     6,    36,    37,   154,     0,     0,
     0,    16,    38,    39,    40,    16,    38,    39,    40,     0,
     0,     0,     0,   155,     0,     0,     0,   155,     0,     0,
     0,     0,     0,     0,     0,     0,   156,     0,     0,     0,
   156,     0,   157,     0,     0,   411,   157,    42,     0,     0,
    43,    42,    44,     0,    43,     0,    44,   121,   122,   123,
   124,   125,   126,   127,   128,   129,   130,   131,   132,     0,
   133,   134,   135,   136,   137,   138,   139,     0,     0,     0,
     0,     0,   219,   121,   122,   123,   124,   125,   126,   127,
   128,   129,   130,   131,   132,     0,   133,   134,   135,   136,
   137,   138,   139,     0,     0,     0,     0,     0,   313,   121,
   122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
   132,     0,   133,   134,   135,   136,   137,   138,   139,     0,
     0,     0,     0,     0,   321,   121,   122,   123,   124,   125,
   126,   127,   128,   129,   130,   131,   132,     0,   133,   134,
   135,   136,   137,   138,   139,     0,     0,     0,     0,     0,
   330,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,     0,   349,   121,   122,   123,
   124,   125,   126,   127,   128,   129,   130,   131,   132,     0,
   133,   134,   135,   136,   137,   138,   139,     0,     0,     0,
     0,     0,   382,   121,   122,   123,   124,   125,   126,   127,
   128,   129,   130,   131,   132,     0,   133,   134,   135,   136,
   137,   138,   139,     0,     0,     0,     0,     0,   389,   121,
   122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
   132,     0,   133,   134,   135,   136,   137,   138,   139,     0,
     0,     0,     0,     0,   410,   121,   122,   123,   124,   125,
   126,   127,   128,   129,   130,   131,   132,     0,   133,   134,
   135,   136,   137,   138,   139,     0,     0,     0,     0,     0,
   418,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,     0,   435,   121,   122,   123,
   124,   125,   126,   127,   128,   129,   130,   131,   132,     0,
   133,   134,   135,   136,   137,   138,   139,     0,     0,     0,
     0,     0,   444,   121,   122,   123,   124,   125,   126,   127,
   128,   129,   130,   131,   132,     0,   133,   134,   135,   136,
   137,   138,   139,     0,     0,     0,     0,     0,   451,   121,
   122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
   132,     0,   133,   134,   135,   136,   137,   138,   139,     0,
     0,     0,     0,     0,   456,   121,   122,   123,   124,   125,
   126,   127,   128,   129,   130,   131,   132,     0,   133,   134,
   135,   136,   137,   138,   139,     0,     0,     0,     0,     0,
   459,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   314,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   315,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   316,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   317,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   318,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   319,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   320,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   367,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   383,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   384,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   385,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   386,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   387,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   388,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   419,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   420,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   421,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   422,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   423,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   436,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   437,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   438,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   439,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   445,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   446,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   447,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   452,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
   453,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,     0,   133,   134,   135,   136,   137,   138,
   139,     0,     0,     0,     0,   457,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,     0,     0,     0,    28,
   121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
   131,   132,     0,   133,   134,   135,   136,   137,   138,   139,
     0,     0,     0,   218,   121,   122,   123,   124,   125,   126,
   127,   128,   129,   130,   131,   132,     0,   133,   134,   135,
   136,   137,   138,   139,     0,     0,   140,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
   134,   135,   136,   137,   138,   139,   122,   123,   124,   125,
   126,   127,   128,   129,     0,     0,   132,     0,   133,   134,
   135,   136,   137,   138,   139,   122,   123,   124,   125,   126,
   127,   128,   129,     0,     0,     0,     0,   133,   134,   135,
   136,   137,   138,   139,   122,-32768,-32768,-32768,   126,   127,
   128,   129,     0,     0,     0,     0,   133,   134,   135,   136,
   137,   138,   139
};

static const short yycheck[] = {     2,
     3,   172,   173,   174,    27,    90,   110,   111,   112,    49,
    27,    42,    43,    44,    45,    46,    27,    20,    21,    22,
    23,    24,    25,    26,    42,    28,    29,    27,    54,    52,
    56,    50,    49,     3,     4,     5,     6,     7,     8,    42,
    43,    52,    50,    46,    14,    15,    16,    17,    50,    49,
    20,    21,    22,    45,    46,     1,    26,    50,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    23,    24,    25,
    50,    19,    19,    53,    50,    55,    54,    18,    56,    27,
    27,    54,    50,    56,    50,    50,    99,   100,   101,   102,
   103,   104,   105,   106,   107,    50,   109,    50,    50,    50,
    50,    50,    18,   217,    50,    50,   287,   202,   121,   122,
   123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
   133,   134,   135,   136,   137,    50,   139,    18,   141,    51,
   143,   159,   145,   146,    51,   148,   149,    50,    50,   152,
    51,    50,    52,    46,    52,   158,   159,    52,     3,     4,
     5,     6,     7,     8,     9,    10,   169,    51,   171,    14,
    15,    16,    17,    52,    52,    20,    21,    22,     0,     0,
   222,    26,   251,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    45,    46,   310,    -1,    -1,    50,    -1,    -1,    53,    -1,
    55,   214,    -1,    -1,    -1,   218,    -1,   220,    -1,   222,
    -1,     3,    -1,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    -1,    -1,    20,    21,
    22,   244,   245,   246,    26,   248,   249,    -1,   251,   252,
    -1,     3,     4,     5,     6,    -1,    -1,    39,    -1,    41,
    -1,    -1,    14,    15,    16,    17,    48,    49,    50,    -1,
   273,    53,    -1,    55,    26,    -1,    -1,     3,     4,     5,
    -1,   284,    -1,    -1,    -1,    -1,    -1,    39,    14,    15,
    16,    17,    -1,    45,     3,     4,     5,    -1,    50,    51,
    -1,    53,    -1,    55,    -1,    14,    15,    16,    17,    -1,
    -1,   314,   315,   316,   317,   318,   319,   320,    -1,    -1,
    -1,    -1,   325,    49,    50,    -1,    -1,    53,    -1,    55,
   333,   334,   335,   336,   337,    -1,    -1,    -1,   341,    -1,
    -1,    50,    51,    28,    53,    -1,    55,    32,    33,    34,
    35,    -1,    -1,    -1,    -1,    40,    41,    42,    43,    44,
    45,    46,    -1,    -1,   367,    -1,   369,   370,   371,    -1,
   373,    -1,    -1,    -1,    -1,    -1,     2,    -1,    -1,    -1,
   383,   384,   385,   386,   387,   388,    -1,    -1,    -1,    -1,
    -1,   394,    -1,   396,    20,    21,    22,    23,    24,    25,
    26,    -1,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
   413,    -1,     3,     4,     5,    -1,   419,   420,   421,   422,
   423,    -1,   425,    14,    15,    16,    17,    -1,    -1,    -1,
    -1,    -1,    -1,   436,   437,   438,   439,    -1,    -1,    -1,
    -1,    -1,   445,   446,   447,    -1,    -1,    -1,    -1,   452,
   453,    -1,    -1,    28,   457,    -1,    -1,    -1,    -1,    50,
    -1,    52,    53,    -1,    55,    40,    41,    42,    43,    44,
    45,    46,    -1,    99,   100,   101,   102,   103,   104,   105,
   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,
   126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
   136,   137,    -1,   139,    -1,   141,    -1,   143,    -1,     3,
     4,     5,     6,    -1,    -1,    -1,    -1,    -1,     2,    -1,
    14,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    26,   169,    -1,    -1,    20,    21,    22,    23,
    24,    25,    26,    -1,    28,    39,    -1,    -1,    -1,    -1,
    -1,    45,    -1,    -1,    -1,    -1,    50,    -1,    52,    53,
    -1,    55,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    -1,    -1,    20,
    21,    22,   218,    -1,   220,    26,   222,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
    -1,    -1,    53,    -1,    55,    99,   100,   101,   102,   103,
   104,   105,   106,   107,    -1,    -1,     3,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,   123,
   124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
   134,   135,   136,   137,    -1,   139,    -1,   141,    -1,   143,
    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,   315,
   316,   317,   318,   319,   320,   169,    -1,    -1,     3,   325,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    -1,    -1,    20,    21,    22,    -1,    42,
    43,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    39,    -1,    41,    -1,    -1,    -1,
    -1,   367,   109,    48,   218,    50,   220,    52,    53,    -1,
    55,    -1,    -1,     3,     4,     5,    -1,   383,   384,   385,
   386,   387,   388,    -1,    14,    15,    16,    17,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,   146,
    -1,   148,   149,    -1,    -1,   152,   109,    -1,    -1,    -1,
    -1,   158,   159,   419,   420,   421,   422,   423,    -1,    -1,
    50,    -1,    52,    53,   171,    55,    -1,    -1,    -1,    -1,
   436,   437,   438,   439,    -1,    -1,    -1,    -1,    -1,   445,
   446,   447,   145,   146,    -1,    -1,   452,   453,    -1,   152,
    -1,   457,    -1,    -1,    -1,   158,   159,    -1,    -1,    -1,
   314,   315,   316,   317,   318,   319,   320,   214,   171,    -1,
     3,   325,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    -1,    -1,    20,    21,    22,
    -1,    -1,    -1,    26,    -1,    -1,    -1,   244,   245,   246,
    -1,   248,   249,    -1,   251,   252,    39,    -1,    41,    -1,
    -1,    -1,    -1,   367,    -1,    48,    -1,    50,    51,    -1,
    53,    -1,    55,    -1,    -1,    -1,   273,    -1,    -1,   383,
   384,   385,   386,   387,   388,    -1,    -1,   284,    -1,    -1,
    -1,    -1,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
     3,     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    14,    15,    16,    17,   419,   420,   421,   422,   423,
   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   436,   437,   438,   439,   333,   334,   335,   336,
   337,   445,   446,   447,   341,    -1,    -1,    50,   452,   453,
    53,    -1,    55,   457,     3,     4,     5,     6,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    -1,
    -1,    -1,   369,   370,   371,    -1,   373,    26,    -1,    -1,
    -1,   334,   335,    -1,    -1,    -1,    -1,    -1,   341,    -1,
    39,    -1,    -1,    -1,    -1,    -1,    45,   394,    -1,   396,
    -1,    50,    -1,    52,    53,    -1,    55,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   413,    -1,   371,    -1,
   373,    -1,    -1,    19,    -1,    -1,    -1,    -1,   425,    -1,
    -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,   396,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   413,    -1,    54,    55,    56,    57,    58,    59,    60,    61,
    -1,    -1,   425,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    -1,    -1,    91,
    -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,   108,    -1,    20,    21,
    22,    -1,    -1,    -1,    26,    -1,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    -1,    48,    -1,    50,    51,
    -1,    53,   144,    55,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   162,   163,   164,   165,   166,   167,   168,    -1,   170,    -1,
    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
   192,    -1,   194,    -1,    -1,    -1,    -1,    -1,   200,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    -1,    -1,    20,    21,    22,    -1,
    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    -1,    48,    -1,    50,    -1,    52,    53,
    -1,    55,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    -1,    40,    41,    42,    43,    44,
    45,    46,    -1,    -1,   276,   277,   278,   279,   280,   281,
    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
    -1,    20,    21,    22,   306,    -1,   308,    26,   310,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
    -1,    50,    -1,    52,    53,    -1,    55,    -1,    -1,    -1,
    -1,    -1,   344,   345,   346,   347,   348,    -1,    -1,    -1,
    -1,   353,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
    16,    17,    -1,   375,   376,   377,   378,    -1,    -1,   381,
    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    39,    -1,    -1,   398,   399,   400,    45,
    -1,    -1,    -1,    -1,    50,    -1,    52,    53,    -1,    55,
    -1,    -1,    -1,   415,   416,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    -1,    -1,    20,    21,    22,    -1,    -1,    -1,    26,
    -1,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    -1,    48,    -1,    50,    -1,    -1,    53,    -1,    55,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    -1,    -1,    20,    21,    22,    -1,
    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    -1,    -1,    -1,    50,    -1,    -1,    53,
    -1,    55,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    -1,    14,    15,    16,    17,    -1,    -1,    20,
    21,    22,    -1,    -1,    -1,    26,    -1,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
    -1,    -1,    53,    -1,    55,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    -1,    -1,    14,    15,    16,    17,
    -1,    -1,    20,    21,    22,    -1,    -1,    -1,    26,    -1,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
    -1,    -1,    50,    -1,    -1,    53,    -1,    55,     3,     4,
     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    14,
    15,    16,    17,    -1,    -1,    20,    21,    22,    -1,    -1,
    -1,    26,    -1,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    -1,    -1,    -1,    50,    -1,    -1,    53,    -1,
    55,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
    -1,    -1,    14,    15,    16,    17,    -1,    -1,    20,    21,
    -1,    -1,    -1,    -1,    26,    -1,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    -1,
    -1,    53,     3,    55,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    -1,    -1,    20,
    21,    22,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,
    41,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    50,
    -1,    52,    53,     3,    55,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
    20,    21,    22,    -1,    -1,    -1,    26,    -1,    -1,    -1,
    -1,     3,     4,     5,     6,    -1,    -1,    -1,    -1,    39,
    -1,    41,    14,    15,    16,    17,    -1,    -1,    48,    -1,
    50,    -1,    -1,    53,    26,    55,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,     3,     4,     5,     6,    39,    -1,    -1,
    -1,    -1,    -1,    45,    14,    15,    16,    17,    50,    -1,
    52,    53,    -1,    55,    -1,    -1,    26,    -1,    -1,     3,
     4,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    39,
    14,    15,    16,    17,    -1,    45,    -1,    -1,    48,    -1,
    50,    -1,    26,    53,    -1,    55,    -1,    -1,    -1,    -1,
    -1,     3,     4,     5,     6,    39,    -1,    -1,    -1,    -1,
    -1,    45,    14,    15,    16,    17,    50,    -1,    52,    53,
    -1,    55,    -1,    -1,    26,    -1,    -1,     3,     4,     5,
     6,    -1,    -1,    -1,    -1,    -1,    -1,    39,    14,    15,
    16,    17,    -1,    45,    -1,    -1,    48,    -1,    50,    -1,
    26,    53,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,
    -1,    -1,    48,    -1,    50,    -1,    -1,    53,    -1,    55,
     3,     4,     5,     6,     3,     4,     5,     6,    -1,    -1,
    -1,    14,    15,    16,    17,    14,    15,    16,    17,    -1,
    -1,    -1,    -1,    26,    -1,    -1,    -1,    26,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,    -1,    -1,
    39,    -1,    45,    -1,    -1,    48,    45,    50,    -1,    -1,
    53,    50,    55,    -1,    53,    -1,    55,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
    40,    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,
    -1,    -1,    52,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
    44,    45,    46,    -1,    -1,    -1,    -1,    -1,    52,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    -1,    40,    41,    42,    43,    44,    45,    46,    -1,
    -1,    -1,    -1,    -1,    52,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,    -1,
    52,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    -1,    52,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
    40,    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,
    -1,    -1,    52,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
    44,    45,    46,    -1,    -1,    -1,    -1,    -1,    52,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    -1,    40,    41,    42,    43,    44,    45,    46,    -1,
    -1,    -1,    -1,    -1,    52,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,    -1,
    52,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    -1,    52,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
    40,    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,
    -1,    -1,    52,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
    44,    45,    46,    -1,    -1,    -1,    -1,    -1,    52,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    -1,    40,    41,    42,    43,    44,    45,    46,    -1,
    -1,    -1,    -1,    -1,    52,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,    -1,
    52,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
    51,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
    46,    -1,    -1,    -1,    -1,    51,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
    -1,    -1,    -1,    50,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    -1,    40,    41,    42,
    43,    44,    45,    46,    -1,    -1,    49,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    41,    42,    43,    44,    45,    46,    28,    29,    30,    31,
    32,    33,    34,    35,    -1,    -1,    38,    -1,    40,    41,
    42,    43,    44,    45,    46,    28,    29,    30,    31,    32,
    33,    34,    35,    -1,    -1,    -1,    -1,    40,    41,    42,
    43,    44,    45,    46,    28,    29,    30,    31,    32,    33,
    34,    35,    -1,    -1,    -1,    -1,    40,    41,    42,    43,
    44,    45,    46
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 178 "parse.y"
{ YYACCEPT; ;
    break;}
case 2:
#line 179 "parse.y"
{ YYACCEPT; ;
    break;}
case 3:
#line 180 "parse.y"
{ YYACCEPT; ;
    break;}
case 4:
#line 181 "parse.y"
{ YYACCEPT; ;
    break;}
case 5:
#line 182 "parse.y"
{ YYACCEPT; ;
    break;}
case 6:
#line 183 "parse.y"
{ YYACCEPT; ;
    break;}
case 7:
#line 184 "parse.y"
{ error_num = EOF_ERROR; YYACCEPT; ;
    break;}
case 8:
#line 185 "parse.y"
{ error_num = EOF_ERROR; YYACCEPT; ;
    break;}
case 9:
#line 186 "parse.y"
{ error_num = EOF_ERROR; YYACCEPT; ;
    break;}
case 10:
#line 187 "parse.y"
{ return_ret = TRUE; yyclearin; YYABORT; ;
    break;}
case 11:
#line 188 "parse.y"
{ return_ret = TRUE; ;
    break;}
case 12:
#line 191 "parse.y"
{ PUSH_ACT(E_SEPAR); ;
    break;}
case 13:
#line 192 "parse.y"
{ PUSH_ACT(E_EQUALS); ;
    break;}
case 14:
#line 193 "parse.y"
{ PUSH_ACT(E_PLUS); ;
    break;}
case 15:
#line 194 "parse.y"
{ PUSH_ACT(E_MINUS); ;
    break;}
case 16:
#line 195 "parse.y"
{ PUSH_ACT(E_MUL); ;
    break;}
case 17:
#line 196 "parse.y"
{ PUSH_ACT(E_DIV); ;
    break;}
case 18:
#line 197 "parse.y"
{ PUSH_ACT(E_MOD); ;
    break;}
case 19:
#line 198 "parse.y"
{ PUSH_ACT(E_EQ_CMP); ;
    break;}
case 20:
#line 199 "parse.y"
{ PUSH_ACT(E_NE_CMP); ;
    break;}
case 21:
#line 200 "parse.y"
{ PUSH_ACT(E_CMP_CMP); ;
    break;}
case 22:
#line 201 "parse.y"
{ PUSH_ACT(E_LT_CMP); ;
    break;}
case 23:
#line 202 "parse.y"
{ PUSH_ACT(E_GT_CMP); ;
    break;}
case 24:
#line 203 "parse.y"
{ PUSH_ACT(E_LE_CMP); ;
    break;}
case 25:
#line 204 "parse.y"
{ PUSH_ACT(E_GE_CMP); ;
    break;}
case 26:
#line 205 "parse.y"
{ PUSH_ACT(E_LOGICAL_AND); ;
    break;}
case 27:
#line 206 "parse.y"
{ PUSH_ACT(E_LOGICAL_OR); ;
    break;}
case 28:
#line 207 "parse.y"
{ PUSH_ACT(E_LOGICAL_XOR); ;
    break;}
case 29:
#line 208 "parse.y"
{ PUSH_ACT(E_LOGICAL_NOT); ;
    break;}
case 30:
#line 209 "parse.y"
{ PUSH_ACT(E_FACT); ;
    break;}
case 31:
#line 210 "parse.y"
{ PUSH_ACT(E_NEG); ;
    break;}
case 32:
#line 211 "parse.y"
{ PUSH_ACT(E_NEG); ;
    break;}
case 33:
#line 212 "parse.y"
{ PUSH_ACT(E_EXP); ;
    break;}
case 34:
#line 214 "parse.y"
{ PUSH_ACT(E_GET_ELEMENT); ;
    break;}
case 35:
#line 216 "parse.y"
{ PUSH_ACT(E_GET_ROW); ;
    break;}
case 36:
#line 218 "parse.y"
{ PUSH_ACT(E_GET_COLUMN); ;
    break;}
case 38:
#line 220 "parse.y"
{ PUSH_FUNC(yyvsp[0].func); ;
    break;}
case 39:
#line 221 "parse.y"
{ PUSH_ACT(E_FUNCDEF); ;
    break;}
case 40:
#line 222 "parse.y"
{ PUSH_ACT(E_WHILE_CONS); ;
    break;}
case 41:
#line 223 "parse.y"
{ PUSH_ACT(E_IF_CONS); ;
    break;}
case 42:
#line 225 "parse.y"
{ PUSH_ACT(E_IFELSE_CONS); ;
    break;}
case 44:
#line 227 "parse.y"
{ if(!push_matrix()) YYERROR; ;
    break;}
case 46:
#line 229 "parse.y"
{ push_null(); ;
    break;}
case 47:
#line 230 "parse.y"
{ pop_notation(); ;
    break;}
case 48:
#line 231 "parse.y"
{ pop_notation(); ;
    break;}
case 49:
#line 232 "parse.y"
{ pop_notation(); ;
    break;}
case 51:
#line 236 "parse.y"
{ if(!push_marker(MATRIX_ROW_START_NODE)) YYERROR; ;
    break;}
case 52:
#line 239 "parse.y"
{ if(!push_matrix_row()) YYERROR; ;
    break;}
case 53:
#line 240 "parse.y"
{ if(!push_marker(MATRIX_START_NODE)) YYERROR; ;
    break;}
case 56:
#line 250 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 57:
#line 252 "parse.y"
{ yyval.func = yyvsp[-3].func ;
    break;}
case 58:
#line 254 "parse.y"
{ yyval.func = yyvsp[-5].func ;
    break;}
case 59:
#line 256 "parse.y"
{ yyval.func = yyvsp[-7].func ;
    break;}
case 60:
#line 258 "parse.y"
{ yyval.func = yyvsp[-9].func ;
    break;}
case 61:
#line 261 "parse.y"
{ yyval.func = yyvsp[-11].func ;
    break;}
case 62:
#line 264 "parse.y"
{ yyval.func = yyvsp[-13].func ;
    break;}
case 63:
#line 267 "parse.y"
{ yyval.func = yyvsp[-15].func ;
    break;}
case 64:
#line 270 "parse.y"
{ yyval.func = yyvsp[-17].func ;
    break;}
case 65:
#line 273 "parse.y"
{ PUSH_ACT(E_SEPAR); ;
    break;}
case 67:
#line 277 "parse.y"
{ PUSH_ACT(E_EQUALS); ;
    break;}
case 68:
#line 278 "parse.y"
{ PUSH_ACT(E_PLUS); ;
    break;}
case 69:
#line 279 "parse.y"
{ PUSH_ACT(E_MINUS); ;
    break;}
case 70:
#line 280 "parse.y"
{ PUSH_ACT(E_MUL); ;
    break;}
case 71:
#line 281 "parse.y"
{ PUSH_ACT(E_DIV); ;
    break;}
case 72:
#line 282 "parse.y"
{ PUSH_ACT(E_MOD); ;
    break;}
case 73:
#line 283 "parse.y"
{ PUSH_ACT(E_EQ_CMP); ;
    break;}
case 74:
#line 284 "parse.y"
{ PUSH_ACT(E_NE_CMP); ;
    break;}
case 75:
#line 285 "parse.y"
{ PUSH_ACT(E_CMP_CMP); ;
    break;}
case 76:
#line 286 "parse.y"
{ PUSH_ACT(E_LT_CMP); ;
    break;}
case 77:
#line 287 "parse.y"
{ PUSH_ACT(E_GT_CMP); ;
    break;}
case 78:
#line 288 "parse.y"
{ PUSH_ACT(E_LE_CMP); ;
    break;}
case 79:
#line 289 "parse.y"
{ PUSH_ACT(E_GE_CMP); ;
    break;}
case 80:
#line 290 "parse.y"
{ PUSH_ACT(E_LOGICAL_AND); ;
    break;}
case 81:
#line 291 "parse.y"
{ PUSH_ACT(E_LOGICAL_OR); ;
    break;}
case 82:
#line 292 "parse.y"
{ PUSH_ACT(E_LOGICAL_XOR); ;
    break;}
case 83:
#line 293 "parse.y"
{ PUSH_ACT(E_LOGICAL_NOT); ;
    break;}
case 84:
#line 294 "parse.y"
{ PUSH_ACT(E_NEG); ;
    break;}
case 85:
#line 295 "parse.y"
{ PUSH_ACT(E_FACT); ;
    break;}
case 86:
#line 296 "parse.y"
{ PUSH_ACT(E_EXP); ;
    break;}
case 87:
#line 298 "parse.y"
{ PUSH_ACT(E_GET_ELEMENT); ;
    break;}
case 88:
#line 300 "parse.y"
{ PUSH_ACT(E_GET_ROW); ;
    break;}
case 89:
#line 302 "parse.y"
{ PUSH_ACT(E_GET_COLUMN); ;
    break;}
case 91:
#line 304 "parse.y"
{ PUSH_FUNC(yyvsp[0].func); ;
    break;}
case 92:
#line 305 "parse.y"
{ PUSH_ACT(E_FUNCDEF); ;
    break;}
case 93:
#line 306 "parse.y"
{ PUSH_ACT(E_WHILE_CONS); ;
    break;}
case 94:
#line 307 "parse.y"
{ PUSH_ACT(E_IF_CONS); ;
    break;}
case 95:
#line 308 "parse.y"
{ PUSH_ACT(E_IFELSE_CONS); ;
    break;}
case 97:
#line 310 "parse.y"
{ if(!push_matrix()) YYERROR; ;
    break;}
case 99:
#line 312 "parse.y"
{ push_null(); ;
    break;}
case 100:
#line 313 "parse.y"
{ pop_notation(); ;
    break;}
case 101:
#line 314 "parse.y"
{ pop_notation(); ;
    break;}
case 102:
#line 315 "parse.y"
{ pop_notation(); ;
    break;}
case 104:
#line 319 "parse.y"
{ if(!push_marker(MATRIX_ROW_START_NODE)) YYERROR; ;
    break;}
case 105:
#line 322 "parse.y"
{ if(!push_matrix_row()) YYERROR; ;
    break;}
case 106:
#line 323 "parse.y"
{ if(!push_marker(MATRIX_START_NODE)) YYERROR; ;
    break;}
case 109:
#line 335 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 110:
#line 337 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 111:
#line 339 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 112:
#line 341 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 113:
#line 343 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 114:
#line 345 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 115:
#line 347 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 116:
#line 349 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 117:
#line 351 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 118:
#line 354 "parse.y"
{ PUSH_ACT(E_SEPAR); ;
    break;}
case 120:
#line 358 "parse.y"
{ PUSH_ACT(E_EQUALS); ;
    break;}
case 121:
#line 359 "parse.y"
{ PUSH_ACT(E_PLUS); ;
    break;}
case 122:
#line 360 "parse.y"
{ PUSH_ACT(E_MINUS); ;
    break;}
case 123:
#line 361 "parse.y"
{ PUSH_ACT(E_MUL); ;
    break;}
case 124:
#line 362 "parse.y"
{ PUSH_ACT(E_DIV); ;
    break;}
case 125:
#line 363 "parse.y"
{ PUSH_ACT(E_MOD); ;
    break;}
case 126:
#line 364 "parse.y"
{ PUSH_ACT(E_EQ_CMP); ;
    break;}
case 127:
#line 365 "parse.y"
{ PUSH_ACT(E_NE_CMP); ;
    break;}
case 128:
#line 366 "parse.y"
{ PUSH_ACT(E_CMP_CMP); ;
    break;}
case 129:
#line 367 "parse.y"
{ PUSH_ACT(E_LT_CMP); ;
    break;}
case 130:
#line 368 "parse.y"
{ PUSH_ACT(E_GT_CMP); ;
    break;}
case 131:
#line 369 "parse.y"
{ PUSH_ACT(E_LE_CMP); ;
    break;}
case 132:
#line 370 "parse.y"
{ PUSH_ACT(E_GE_CMP); ;
    break;}
case 133:
#line 371 "parse.y"
{ PUSH_ACT(E_LOGICAL_AND); ;
    break;}
case 134:
#line 372 "parse.y"
{ PUSH_ACT(E_LOGICAL_OR); ;
    break;}
case 135:
#line 373 "parse.y"
{ PUSH_ACT(E_LOGICAL_XOR); ;
    break;}
case 136:
#line 374 "parse.y"
{ PUSH_ACT(E_LOGICAL_NOT); ;
    break;}
case 137:
#line 375 "parse.y"
{ PUSH_ACT(E_NEG); ;
    break;}
case 138:
#line 376 "parse.y"
{ PUSH_ACT(E_FACT); ;
    break;}
case 139:
#line 377 "parse.y"
{ PUSH_ACT(E_EXP); ;
    break;}
case 140:
#line 379 "parse.y"
{ PUSH_ACT(E_GET_ELEMENT); ;
    break;}
case 141:
#line 381 "parse.y"
{ PUSH_ACT(E_GET_ROW); ;
    break;}
case 142:
#line 383 "parse.y"
{ PUSH_ACT(E_GET_COLUMN); ;
    break;}
case 144:
#line 385 "parse.y"
{ PUSH_FUNC(yyvsp[0].func); ;
    break;}
case 145:
#line 386 "parse.y"
{ PUSH_ACT(E_FUNCDEF); ;
    break;}
case 146:
#line 387 "parse.y"
{ PUSH_ACT(E_WHILE_CONS); ;
    break;}
case 147:
#line 388 "parse.y"
{ PUSH_ACT(E_IF_CONS); ;
    break;}
case 148:
#line 390 "parse.y"
{ PUSH_ACT(E_IFELSE_CONS); ;
    break;}
case 150:
#line 392 "parse.y"
{ if(!push_matrix()) YYERROR; ;
    break;}
case 152:
#line 394 "parse.y"
{ push_null(); ;
    break;}
case 153:
#line 395 "parse.y"
{ pop_notation(); ;
    break;}
case 154:
#line 396 "parse.y"
{ pop_notation(); ;
    break;}
case 155:
#line 397 "parse.y"
{ pop_notation(); ;
    break;}
case 157:
#line 401 "parse.y"
{ if(!push_marker(MATRIX_ROW_START_NODE)) YYERROR; ;
    break;}
case 158:
#line 404 "parse.y"
{ if(!push_matrix_row()) YYERROR; ;
    break;}
case 159:
#line 405 "parse.y"
{ if(!push_marker(MATRIX_START_NODE)) YYERROR; ;
    break;}
case 162:
#line 415 "parse.y"
{ yyval.func = yyvsp[0].func ;
    break;}
case 163:
#line 417 "parse.y"
{ yyval.func = yyvsp[-1].func ;
    break;}
case 164:
#line 419 "parse.y"
{ yyval.func = yyvsp[-2].func ;
    break;}
case 165:
#line 421 "parse.y"
{ yyval.func = yyvsp[-3].func ;
    break;}
case 166:
#line 423 "parse.y"
{ yyval.func = yyvsp[-4].func ;
    break;}
case 167:
#line 425 "parse.y"
{ yyval.func = yyvsp[-5].func ;
    break;}
case 168:
#line 427 "parse.y"
{ yyval.func = yyvsp[-6].func ;
    break;}
case 169:
#line 429 "parse.y"
{ yyval.func = yyvsp[-7].func ;
    break;}
case 170:
#line 431 "parse.y"
{ yyval.func = yyvsp[-8].func ;
    break;}
case 171:
#line 434 "parse.y"
{ PUSH_FAKEFUNC(yyvsp[0].func); ;
    break;}
case 174:
#line 441 "parse.y"
{
				stack_push(&evalstack,makenum(yyvsp[0].val));
				mpw_clear(yyvsp[0].val);
			;
    break;}
case 175:
#line 447 "parse.y"
{
				stack_push(&evalstack,makenum(yyvsp[0].val));
				mpw_clear(yyvsp[0].val);
			;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 453 "parse.y"

